"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebWorkerLoader = void 0;
const Comlink = __importStar(require("comlink"));
/**
 * Proxies requests to web worker loader.
 */
class WebWorkerLoader {
    constructor(proxy) {
        this.proxy = proxy;
    }
    static async load(id, options, resolved, fromSequenceNumber) {
        const ProxyLoader = Comlink.wrap(new Worker("/public/scripts/dist/worker.min.js"));
        const proxyLoader = await new ProxyLoader(id, options, resolved, fromSequenceNumber);
        return new WebWorkerLoader(proxyLoader);
    }
    get IFluidRouter() { return this; }
    get IFluidRunnable() { return this; }
    async request(request) {
        const response = await this.proxy.request(request);
        if (response.status !== 200
            || (response.mimeType !== "fluid/component" && response.mimeType !== "fluid/object")) {
            return response;
        }
        return { status: 200, mimeType: "fluid/object", value: this };
    }
    async run(...args) {
        return this.proxy.run(...args);
    }
    async stop(reason) {
        return this.proxy.stop(reason);
    }
    async resolve(request, pendingLocalState) {
        return this.proxy.resolve(request, pendingLocalState);
    }
    async createDetachedContainer(source) {
        return this.proxy.createDetachedContainer(source);
    }
    async rehydrateDetachedContainerFromSnapshot(source) {
        return this.proxy.rehydrateDetachedContainerFromSnapshot(source);
    }
}
exports.WebWorkerLoader = WebWorkerLoader;
//# sourceMappingURL=webWorkerLoader.js.map